<template>
  <div>
    <div>
      <div class="container">
        <header class="jumbotron">
          <div>Przeglądasz ul: <strong>{{ beehive.beehiveName }}</strong></div>
          <hr>
          <button class="btn btn-secondary mr-1" v-on:click="editBeehive(beehive.id, beehive.beegardenId)">Edytuj</button>
          <button class="btn btn-primary mr-1" v-on:click="addHoneyCollection(beehive.id)">Dodaj zbiory</button>
          <button class="btn btn-primary mr-1" v-on:click="addInspection(beehive.id)">Dodaj przegląd</button>
          <button class="btn btn-primary mr-1" v-on:click="addQueen(beehive.id)">Dodaj matkę</button>
          <button class="btn btn-primary mr-1" v-if="sensors.toString().length < 3" v-on:click="addSensor(beehive.id)">
            Dodaj sensor
          </button>
          <button class="btn btn-danger mr-1" v-on:click="deleteSpecificBeehive(beehive.id)">Usuń</button>
        </header>

        <div class="row" style="margin-bottom: 5%;">
          <div class="col-md-8">
            <div class="card mb-3">
              <div class="card-body">
                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Typ ula: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.type }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Siła ula: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.force }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Zamontowany izolator? </h6>
                  </div>
                  <div v-if="beehive.barrier" class="col-sm-9 text-secondary">
                    Tak
                  </div>
                  <div v-if="!beehive.barrier" class="col-sm-9 text-secondary">
                    Nie
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Dennica: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.bottom }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Data utworzenia: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.dateOfCreation }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Liczba ramek: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.framesAmount }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Podgrzewacz: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.heater }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Miód w ulu: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.honey }}%
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Szerokość wylotka: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.inletWidth }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Głód w ulu: </h6>
                  </div>
                  <div v-if="beehive.lackOfFood" class="col-sm-9 text-secondary">
                    Tak
                  </div>
                  <div v-if="!beehive.lackOfFood" class="col-sm-9 text-secondary">
                    Nie
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Zamontowany poławiacz pyłku? </h6>
                  </div>
                  <div v-if="beehive.poolenTrapper" class="col-sm-9 text-secondary">
                    Tak
                  </div>
                  <div v-if="!beehive.poolenTrapper" class="col-sm-9 text-secondary">
                    Nie
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Propolis w ulu: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.propolis }}%
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Temperament rodziny: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.temperament }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Nastrój rojowy? </h6>
                  </div>
                  <div v-if="beehive.swarmMood" class="col-sm-9 text-secondary">
                    Tak
                  </div>
                  <div v-if="!beehive.swarmMood" class="col-sm-9 text-secondary">
                    Nie
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Ilość ramek pracy: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.workFramesAmount }}
                  </div>
                </div>
                <hr>

                <div class="row">
                  <div class="col-sm-3">
                    <h6 class="mb-0">Ilość korpusów: </h6>
                  </div>
                  <div class="col-sm-9 text-secondary">
                    {{ beehive.trunksAmount }}
                  </div>
                </div>
                <hr>

              </div>
            </div>
          </div>
        </div>


        <div style="margin-bottom: 5%;" class="container">
          <div class="row">


            <div class="col-sm" style="border-style: groove;">
              <div v-if="honeycollections.toString().length > 3">
                <h3>Zbiory: </h3>

                <h4>Ilość Twoich zbiorów: {{ honeycollections.length }}!</h4>

                <button class="btn btn-primary mr-1" v-on:click="goToCollections(beehive.id)">
                  Sprawdź je!
                </button>
              </div>

              <div v-if="honeycollections.toString().length < 3">
                <h3>Zbiory: </h3>

                <h4>Brak zbiorów!</h4>

                <button class="btn btn-primary mr-1" v-on:click="addHoneyCollection(beehive.id)">
                  Dodaj je!
                </button>
              </div>

            </div>


            <div class="col-sm" style="border-style: groove;">
              <div v-if="inspections.toString().length > 3">
                <h3>Przeglądy: </h3>
                <h4>Ilość Twoich przeglądów: {{ inspections.length }}!</h4>

                <button class="btn btn-primary mr-1" v-on:click="goToInspections(beehive.id)">
                  Sprawdź je!
                </button>
              </div>

              <div v-if="inspections.toString().length < 3">
                <h3>Przeglądy: </h3>

                <h4>Brak przeglądów!</h4>

                <button class="btn btn-primary mr-1" v-on:click="addInspection(beehive.id)">
                  Dodaj je!
                </button>
              </div>

            </div>

            <div class="col-sm" style="border-style: groove;">
              <div v-if="queens.toString().length > 3">
                <h3>Królowe: </h3>
                <h4>Ilość Twoich Matek: {{ queens.length }}!</h4>

                <button class="btn btn-primary mr-1" v-on:click="goToQueens(beehive.id)">
                  Sprawdź je!
                </button>
              </div>

              <div v-if="queens.toString().length < 3">
                <h3>Królowe: </h3>

                <h4>Brak królowej!</h4>

                <button class="btn btn-primary mr-1" v-on:click="addQueen(beehive.id)">
                  Dodaj królową!
                </button>
              </div>
            </div>

          </div>
        </div>
      </div>
    </div>


    <div v-if="sensors.toString().length > 3" style="border-style: groove;">
      <h3>Sensor: </h3>

      <div v-for="sensor in sensors" v-bind:key="sensor.id">

        <div class="col-sm-3">
          <strong>Nr: </strong> {{ sensor.phoneNo }}
        </div>
        <hr>

        <button class="btn btn-primary mr-1" v-on:click="goToSensor(sensor.id)">Sprawdź!</button>
        <button class="btn btn-secondary mr-1" v-on:click="editSensor(sensor.id, beehive.id)">Edytuj sensor</button>
        <button class="btn btn-danger mr-1" v-on:click="deleteSensor(sensor.id, beehive.id)">Usuń sensor</button>

      </div>
    </div>

    <div v-if="sensors.toString().length < 3" style="border-style: groove;">
      <h3>Sensor: </h3>

      <h4>Brak sensora!</h4>

      <button class="btn btn-primary mr-1" v-on:click="addSensor(beehive.id)">
        Dodaj go!
      </button>

    </div>

    <br />

  </div>

</template>

<script>

import BeehiveService from "@/services/beehive.service";
import HoneycollectionService from "@/services/honeycollection.service";
import InspectionService from "@/services/inspection.service";
import QueenService from "@/services/queen.service";
import SensorService from "@/services/sensor.service";


export default {
  name: 'Beehive',
  data() {
    return {
      beehive: '',
      honeycollections: '',
      inspections: '',
      queens: '',
      sensors: '',
      sensordatas: '',
      gotSensorData: false,
      emiter: []
    }
  },
  props: {
    'one_specific_beehive': {}
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beehiveid) {

      // eslint-disable-next-line no-console
      console.log("Get beehive with id: " + this.$route.query.beehiveid)

      BeehiveService.getBeehiveById(this.$route.query.beehiveid).then(
          response => {
            this.beehive = response.data;
          },
          error => {
            this.beehive =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      HoneycollectionService.getHoneyCollectionsByBeehiveId(this.$route.query.beehiveid).then(
          response => {
            this.honeycollections = response.data;
          },
          error => {
            this.honeycollections =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      InspectionService.getInspectionsByBeehiveId(this.$route.query.beehiveid).then(
          response => {
            this.inspections = response.data;
          },
          error => {
            this.inspections =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      QueenService.getQueensByBeehiveId(this.$route.query.beehiveid).then(
          response => {
            this.queens = response.data;
          },
          error => {
            this.queens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      SensorService.getSensorsByBeehiveId(this.$route.query.beehiveid).then(
          response => {
            this.sensors = response.data;
          },
          error => {
            this.sensors =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  },
  methods: {

    goToCollections(beehiveId) {
      this.$router.push('/honeycollections?beehiveId=' + beehiveId);
    },

    goToInspections(beehiveId) {
      this.$router.push('/inspections?beehiveId=' + beehiveId);
    },

    goToQueens(beehiveId) {
      this.$router.push('/beequeens?beehiveId=' + beehiveId);
    },

    editBeehive(beehiveId, beegardenId) {
      this.$router.push('/editbeehive?beehiveId=' + beehiveId + '&beegardenId=' + beegardenId);
    },

    addHoneyCollection(beehiveId) {
      this.$router.push('/addhoneycollection?beehiveId=' + beehiveId);
    },

    addInspection(beehiveId) {
      this.$router.push('/addinspection?beehiveId=' + beehiveId);
    },

    addQueen(beehiveId) {
      this.$router.push('/addqueen?beehiveId=' + beehiveId);
    },

    addSensor(beehiveId) {
      this.$router.push('/addsensor?beehiveId=' + beehiveId);
    },

    editInspection(inspectionId, beehiveId) {
      this.$router.push('/editinspection?inspectionId=' + inspectionId + '&beehiveId=' + beehiveId);
    },

    editQueen(queenId, beehiveId) {
      this.$router.push('/editqueen?queenId=' + queenId + '&beehiveId=' + beehiveId);
    },

    editSensor(queenId, beehiveId) {
      this.$router.push('/editsensor?sensorId=' + queenId + '&beehiveId=' + beehiveId);
    },

    deleteSpecificBeehive(beehiveId) {

      if (confirm("Jesteś pewny? Usuniesz ul i wszystkie należące do niego detale.")) {
        BeehiveService.deleteSpecificBeehive(beehiveId).then(
            response => {
              this.beegardens = response.data;
              alert('Usunięcie ula przebiegło pomyślnie')
              this.$router.push('/boardbeehives')
            },
            error => {
              this.beegardens =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        );
      }
    },

    deleteSensor(sensorId, beehiveId) {

      if (confirm("Jesteś pewny?")) {
        SensorService.deleteSpecificSensor(sensorId).then(
            response => {
              this.sensors = response.data;
              alert('Usunięcie sensora przebiegło pomyślnie')
              // eslint-disable-next-line no-unused-vars
              this.$router.push('/beehive?beehiveid=' + beehiveId).catch(err => {
              });
            },
            error => {
              this.sensors =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        );
      }
    },

    goToSensor(sensorId) {
      this.$router.push('/sensor?sensorId=' + sensorId)
    },

  }
};
</script>
